--[[	*** Historia ***
Written by : Yukyuk, EU-Moonglade
--]]

-------------------------------------------------------------------------------
--  From _Global to local.
-------------------------------------------------------------------------------
local _G = _G


-------------------------------------------------------------------------------
--  AddOn namespace.
-------------------------------------------------------------------------------
local FOLDER_NAME, private = ...

local cfg = private.cfg
local addon = cfg.addon_name


-------------------------------------------------------------------------------
--  Libstubs.
-------------------------------------------------------------------------------
local L 		= LibStub("AceLocale-3.0"):GetLocale("Historia")
local LibQTip 	= LibStub:GetLibrary("LibQTip-1.0")

local Historia_HIG1_Buttons = 12
local Historia_HIC1_Buttons = 12
local Historia_HIA1_Buttons = 15
local Historia_NUMBEROFRANKS = 15
local Historia_HIG1_Text = {1,5,25,50,75,100,150,200,250,500,750,1000}
local Historia_HIC1_Text = {500,1000,2500,5000,7500,10000,20000,30000,40000,100000,250000,500000}
local Historia_HIA1_Text = {1,5,10,15,20,25,30,35,40,45,50,55,60,70,80}

local Historia_Logos_Alliance = {
	[1] = cfg.Icons .."AllianceRank1",
	[2] = cfg.Icons .."AllianceRank2",
	[3] = cfg.Icons .."AllianceRank3",
	[4] = cfg.Icons .."AllianceRank4",
	[5] = cfg.Icons .."AllianceRank5",
	[6] = cfg.Icons .."AllianceRank6",
	[7] = cfg.Icons .."AllianceRank7",
	[8] = cfg.Icons .."AllianceRank8",
	[9] = cfg.Icons .."AllianceRank9",
	[10] = cfg.Icons .."AllianceRank10",
	[11] = cfg.Icons .."AllianceRank11",
	[12] = cfg.Icons .."AllianceRank12",
	[13] = cfg.Icons .."AllianceRank13",	
	[14] = cfg.Icons .."AllianceRank14",
	[15] = cfg.Icons .."AllianceRank15",	
}

local Historia_Text_Alliance = {
	[1] = {[1] = L["Private"],		[2] = ""},
	[2] = {[1] = L["Corporal"],		[2] = ""},
	[3] = {[1] = L["Sergeant"],		[2] = ""},
	[4] = {[1] = L["Master"],		[2] = L["Sergeant"]},
	[5] = {[1] = L["Sergeant"],		[2] = L["Major"]},
	[6] = {[1] = L["Knight"],		[2] = ""},
	[7] = {[1] = L["Knight"],		[2] = L["Lieutenant"]},
	[8] = {[1] = L["Knight"],		[2] = L["Captain"]},
	[9] = {[1] = L["Knight"],		[2] = L["Champion"]},
	[10] = {[1] = L["Lieutenant"],	[2] = L["Commander"]},
	[11] = {[1] = L["Commander"],	[2] = ""},
	[12] = {[1] = L["Marshal"],		[2] = ""},
	[13] = {[1] = L["Field"],		[2] = L["Marshal"]},
	[14] = {[1] = L["Grand"],		[2] = L["Marshal"]},
	[15] = {[1] = L["Alliance"],	[2] = L["Champion"]},
}


local Historia_Logos_Horde = {
	[1] = cfg.Icons .."HordeRank1",
	[2] = cfg.Icons .."HordeRank2",
	[3] = cfg.Icons .."HordeRank3",
	[4] = cfg.Icons .."HordeRank4",
	[5] = cfg.Icons .."HordeRank5",
	[6] = cfg.Icons .."HordeRank6",
	[7] = cfg.Icons .."HordeRank7",
	[8] = cfg.Icons .."HordeRank8",
	[9] = cfg.Icons .."HordeRank9",
	[10] = cfg.Icons .."HordeRank10",
	[11] = cfg.Icons .."HordeRank11",
	[12] = cfg.Icons .."HordeRank12",
	[13] = cfg.Icons .."HordeRank13",	
	[14] = cfg.Icons .."HordeRank14",
	[15] = cfg.Icons .."HordeRank15",	
}

local Historia_Text_Horde = {
	[1] = {[1] = L["Scout"],		[2] = ""},
	[2] = {[1] = L["Grunt"],		[2] = ""},
	[3] = {[1] = L["Sergeant"],		[2] = ""},
	[4] = {[1] = L["Senior"],		[2] = L["Sergeant"]},
	[5] = {[1] = L["First"],		[2] = L["Sergeant"]},
	[6] = {[1] = L["Stone"],		[2] = L["Guard"]},
	[7] = {[1] = L["Blood"],		[2] = L["Guard"]},
	[8] = {[1] = L["Legionnare"],	[2] = ""},
	[9] = {[1] = L["Centurion"],	[2] = ""},
	[10] = {[1] = L["Champion"],	[2] = ""},
	[11] = {[1] = L["Lieutenant"],	[2] = L["General"]},
	[12] = {[1] = L["General"],		[2] = ""},
	[13] = {[1] = L["Warlord"],		[2] = ""},
	[14] = {[1] = L["High"],		[2] = L["Warlord"]},
	[15] = {[1] = L["Horde"],		[2] = L["Champion"]},
}

local counter
local Professions_Goal	= 5	
local Professions_Tab = {}	--	This table is used in the professions achievement
local WeaponSkills_Goal	= 4	
local WeaponSkills_Tab = {}	--	This table is used in the weaopon skills achievement


--------------------------------------------------------------------------------
--  This is the Historia Achievements frame
--------------------------------------------------------------------------------	
function Historia_Achievements()
	local Historia_HA = CreateFrame("Frame","Historia_HA",Historia_UI)
	Historia_HA:SetID(1)
	Historia_HA:SetPoint("TOP", "Historia_UI", 0, -16)
	Historia_HA:SetPoint("BOTTOM", "Historia_UI", 0, 16)
	Historia_HA:SetPoint("LEFT", "Historia_UI", 16, 0)
	Historia_HA:SetPoint("RIGHT", "Historia_UI", -16, 0)
	Historia_HA:SetBackdrop(cfg.Historia_backdrop3)
	
	--  Create a frame for the header Achievements info.
	local Historia_HA_H = CreateFrame("Frame","Historia_HA_H",Historia_HA)
	Historia_HA_H:SetPoint("TOPLEFT","Historia_HA",0,0)
	Historia_HA_H:SetPoint("BOTTOMRIGHT","Historia_HA","TOPRIGHT",0,-48)
	Historia_HA_H:SetBackdrop(cfg.Historia_backdrop2)	
	
	Historia_HA_H.F1 = Historia_HA_H:CreateFontString(nil,"ARTWORK","GameFontNormalHuge")
	Historia_HA_H.F1:SetPoint("CENTER","Historia_HA_H",0,0)
	Historia_HA_H.F1:SetText(L["Historia Achievements"])

	--  Create a frame for the Achievements rank.
	local Historia_HA_R = CreateFrame("Frame","Historia_HA_R",Historia_HA)
	Historia_HA_R:SetPoint("TOPRIGHT","Historia_HA_H","BOTTOMRIGHT",0,-16)
	Historia_HA_R:SetPoint("BOTTOMLEFT","Historia_HA_H","BOTTOMRIGHT",-196,-212)
	Historia_HA_R:SetBackdrop(cfg.Historia_backdrop2)	

	Historia_HA_R.F1 = Historia_HA_R:CreateFontString(nil,"ARTWORK","GameFontNormalHuge")
	Historia_HA_R.F1:SetPoint("TOP","Historia_HA_R",0,-16)
	Historia_HA_R.F1:SetText(L["Achievement rank"])	
	
	Historia_HA_R.F2 = Historia_HA_R:CreateFontString(nil,"ARTWORK","GameFontNormalHuge")
	Historia_HA_R.F2:SetPoint("BOTTOM","Historia_HA_R",0,40)
	Historia_HA_R.F2:SetText("")
	
	Historia_HA_R.F3 = Historia_HA_R:CreateFontString(nil,"ARTWORK","GameFontNormalHuge")
	Historia_HA_R.F3:SetPoint("BOTTOM","Historia_HA_R",0,16)
	Historia_HA_R.F3:SetText("")	

	Historia_HA_R.icon1 = Historia_HA_R:CreateTexture(nil,"ARTWORK")
	Historia_HA_R.icon1:SetSize(64,64)
	Historia_HA_R.icon1:SetPoint("TOP",0,-60)

	Historia_HIG1_labels()	
	Historia_HIL1_labels()
	Historia_HIC1_labels()	
	Historia_HIP1_labels()
	Historia_HIS1_labels()
	Historia_HIS2_labels()	
	Historia_HIQ1_labels()
	Historia_HIA1_labels()	

	Historia_HA:Hide()
end	


-------------------------------------------------------------------------------
--  Create the General Achievements
-------------------------------------------------------------------------------
function Historia_HIG1_labels()
	local Historia_HIG1 = CreateFrame("FRAME", "Historia_HIG1", Historia_HA)
	Historia_HIG1:SetPoint("TOPLEFT","Historia_HA_H","BOTTOMLEFT",0,-16)
	Historia_HIG1:SetPoint("BOTTOMRIGHT","Historia_HA_H",0,-64)

	Historia_HIG1.F1 = Historia_HIG1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIG1.F1:SetPoint("LEFT" ,"Historia_HIG1", 8, 0)
	Historia_HIG1.F1:SetText(GENERAL .. ":")	
				   
	Historia_HIG1.list = {}
	for i=1,Historia_HIG1_Buttons do
		Historia_HIG1.list[i] = CreateFrame("Button",nil,Historia_HIG1)
		Historia_HIG1.list[i]:SetSize(40,40)
		Historia_HIG1.list[i]:SetPoint("LEFT",Historia_HIG1,(i-1)*44+104, 0)
		Historia_HIG1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIG1.list[i]:Show()
		Historia_HIG1.list[i].tooltip = 
			cfg.Historia_SetTooltip(Historia_HIG1.list[i], 
			L["HISTORIA_HIG1_1"] .. cfg.colors["Orange Red"] .. Historia_HIG1_Text[i] .. cfg.colors["End"] .. L["HISTORIA_HIG1_2"])	
		
		Historia_HIG1.list[i].te1 = Historia_HIG1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIG1.list[i].te1:SetSize(20,20)
		Historia_HIG1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIG1.list[i].te1:SetPoint("TOP",Historia_HIG1.list[i],0,-4)
		Historia_HIG1.list[i].te1:Hide()	
		
		Historia_HIG1.list[i].te2 = Historia_HIG1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIG1.list[i].te2:SetSize(20,20)		
		Historia_HIG1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIG1.list[i].te2:SetPoint("TOP",Historia_HIG1.list[i],0,-4)
		Historia_HIG1.list[i].te2:Show()

		Historia_HIG1.list[i].F1 = Historia_HIG1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIG1.list[i].F1:SetPoint("BOTTOM",Historia_HIG1.list[i],0,4)
		Historia_HIG1.list[i].F1:SetText(Historia_HIG1_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Create the Level Achievements
-------------------------------------------------------------------------------
function Historia_HIL1_labels()
	local Historia_HIL1 = CreateFrame("FRAME", "Historia_HIL1", Historia_HA)
	Historia_HIL1:SetPoint("TOPLEFT","Historia_HIG1","BOTTOMLEFT",0,0)
	Historia_HIL1:SetPoint("BOTTOMRIGHT","Historia_HIG1",0,-46)

	Historia_HIL1.F1 = Historia_HIL1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIL1.F1:SetPoint("LEFT" ,"Historia_HIL1", 8, 0)
	Historia_HIL1.F1:SetText(L["Levels"] .. ":")	
				   
	Historia_HIL1.list = {}
	for i=1,cfg.Historia_HIL1_Buttons do
		Historia_HIL1.list[i] = CreateFrame("Button",nil,Historia_HIL1)
		Historia_HIL1.list[i]:SetSize(40,40)
		Historia_HIL1.list[i]:SetPoint("LEFT",Historia_HIL1,(i-1)*44+104, 0)
		Historia_HIL1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIL1.list[i]:Show()
		Historia_HIL1.list[i].tooltip = 
			cfg.Historia_SetTooltip(Historia_HIL1.list[i], 
			L["HISTORIA_HIL1_1"] .. cfg.colors["Copper"] .. cfg.Historia_HIL1_Text[i] .. cfg.colors["End"])	
		
		Historia_HIL1.list[i].te1 = Historia_HIL1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIL1.list[i].te1:SetSize(20,20)
		Historia_HIL1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIL1.list[i].te1:SetPoint("TOP",Historia_HIL1.list[i],0,-4)
		Historia_HIL1.list[i].te1:Hide()	
		
		Historia_HIL1.list[i].te2 = Historia_HIL1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIL1.list[i].te2:SetSize(20,20)		
		Historia_HIL1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIL1.list[i].te2:SetPoint("TOP",Historia_HIL1.list[i],0,-4)
		Historia_HIL1.list[i].te2:Show()

		Historia_HIL1.list[i].F1 = Historia_HIL1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIL1.list[i].F1:SetPoint("BOTTOM",Historia_HIL1.list[i],0,4)
		Historia_HIL1.list[i].F1:SetText(cfg.Historia_HIL1_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Create the Currency Achievements
-------------------------------------------------------------------------------
function Historia_HIC1_labels()
	local Historia_HIC1 = CreateFrame("FRAME", "Historia_HIC1", Historia_HA)
	Historia_HIC1:SetPoint("TOPLEFT","Historia_HIL1","BOTTOMLEFT",0,0)
	Historia_HIC1:SetPoint("BOTTOMRIGHT","Historia_HIL1",0,-46)

	Historia_HIC1.F1 = Historia_HIC1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIC1.F1:SetPoint("LEFT" ,"Historia_HIC1", 8, 0)
	Historia_HIC1.F1:SetText(CURRENCY .. ":")	
				   
	Historia_HIC1.list = {}
	for i=1,Historia_HIC1_Buttons do
		Historia_HIC1.list[i] = CreateFrame("Button",nil,Historia_HIC1)
		Historia_HIC1.list[i]:SetSize(40,40)
		Historia_HIC1.list[i]:SetPoint("LEFT",Historia_HIC1,(i-1)*44+104, 0)
		Historia_HIC1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIC1.list[i]:Show()
		Historia_HIC1.list[i].tooltip = 
			cfg.Historia_SetTooltip(Historia_HIC1.list[i], 
			L["HISTORIA_HIC1_1"] .. GetCoinTextureString(Historia_HIC1_Text[i]) .. L["HISTORIA_HIC1_2"])	
		
		Historia_HIC1.list[i].te1 = Historia_HIC1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIC1.list[i].te1:SetSize(20,20)
		Historia_HIC1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIC1.list[i].te1:SetPoint("TOP",Historia_HIC1.list[i],0,-4)
		Historia_HIC1.list[i].te1:Hide()	
		
		Historia_HIC1.list[i].te2 = Historia_HIC1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIC1.list[i].te2:SetSize(20,20)		
		Historia_HIC1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIC1.list[i].te2:SetPoint("TOP",Historia_HIC1.list[i],0,-4)
		Historia_HIC1.list[i].te2:Show()

		Historia_HIC1.list[i].F1 = Historia_HIC1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIC1.list[i].F1:SetPoint("BOTTOM",Historia_HIC1.list[i],0,4)
		Historia_HIC1.list[i].F1:SetText(GetCoinTextureString(Historia_HIC1_Text[i]))		
	end	
end


-------------------------------------------------------------------------------
--  Create the Professions Achievements
-------------------------------------------------------------------------------
function Historia_HIP1_labels()
	local Historia_HIP1 = CreateFrame("FRAME", "Historia_HIP1", Historia_HA)
	Historia_HIP1:SetPoint("TOPLEFT","Historia_HIC1","BOTTOMLEFT",0,0)
	Historia_HIP1:SetPoint("BOTTOMRIGHT","Historia_HIC1",0,-46)

	Historia_HIP1.F1 = Historia_HIP1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIP1.F1:SetPoint("LEFT" ,"Historia_HIP1", 8, 0)
	Historia_HIP1.F1:SetText(TUTORIAL_TITLE38 .. ":")	
				   
	Historia_HIP1.list = {}
	for i=1,cfg.Historia_HIP1_Buttons do
		Historia_HIP1.list[i] = CreateFrame("Button",nil,Historia_HIP1)
		Historia_HIP1.list[i]:SetSize(40,40)
		Historia_HIP1.list[i]:SetPoint("LEFT",Historia_HIP1,(i-1)*44+104, 0)
		Historia_HIP1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIP1.list[i]:Show()
		Historia_HIP1.list[i].tooltip = 
			cfg.Historia_SetTooltip(Historia_HIP1.list[i], 
			L["HISTORIA_HIP1_1"] .. cfg.colors["Silver"] .. cfg.Historia_HIP1_Text[i] .. cfg.colors["End"] .. L["HISTORIA_HIP1_2"])	
		
		Historia_HIP1.list[i].te1 = Historia_HIP1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIP1.list[i].te1:SetSize(20,20)
		Historia_HIP1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIP1.list[i].te1:SetPoint("TOP",Historia_HIP1.list[i],0,-4)
		Historia_HIP1.list[i].te1:Hide()	
		
		Historia_HIP1.list[i].te2 = Historia_HIP1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIP1.list[i].te2:SetSize(20,20)		
		Historia_HIP1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIP1.list[i].te2:SetPoint("TOP",Historia_HIP1.list[i],0,-4)
		Historia_HIP1.list[i].te2:Show()

		Historia_HIP1.list[i].F1 = Historia_HIP1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIP1.list[i].F1:SetPoint("BOTTOM",Historia_HIP1.list[i],0,4)
		Historia_HIP1.list[i].F1:SetText(cfg.Historia_HIP1_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Create the Skills (Weapon Skills) Achievements
-------------------------------------------------------------------------------
function Historia_HIS1_labels()
	local Historia_HIS1 = CreateFrame("FRAME", "Historia_HIS1", Historia_HA)
	Historia_HIS1:SetPoint("TOPLEFT","Historia_HIP1","BOTTOMLEFT",0,0)
	Historia_HIS1:SetPoint("BOTTOMRIGHT","Historia_HIP1",0,-46)

	Historia_HIS1.F1 = Historia_HIS1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIS1.F1:SetPoint("LEFT" ,"Historia_HIS1", 8, 0)
	Historia_HIS1.F1:SetText(L["Weapon skills"] .. ":")	
				   
	Historia_HIS1.list = {}
	for i=1,cfg.Historia_HIS1_Buttons do
		Historia_HIS1.list[i] = CreateFrame("Button",nil,Historia_HIS1)
		Historia_HIS1.list[i]:SetSize(40,40)
		Historia_HIS1.list[i]:SetPoint("LEFT",Historia_HIS1,(i-1)*44+104, 0)
		Historia_HIS1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIS1.list[i]:Show()
		Historia_HIS1.list[i].tooltip = 
			cfg.Historia_SetTooltip(Historia_HIS1.list[i], 
			L["HISTORIA_HIS1_1"] .. cfg.colors["Gold"] .. cfg.Historia_HIS1_Text[i] .. cfg.colors["End"] .. L["HISTORIA_HIS1_2"])	
		
		Historia_HIS1.list[i].te1 = Historia_HIS1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIS1.list[i].te1:SetSize(20,20)
		Historia_HIS1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIS1.list[i].te1:SetPoint("TOP",Historia_HIS1.list[i],0,-4)
		Historia_HIS1.list[i].te1:Hide()	
		
		Historia_HIS1.list[i].te2 = Historia_HIS1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIS1.list[i].te2:SetSize(20,20)		
		Historia_HIS1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIS1.list[i].te2:SetPoint("TOP",Historia_HIS1.list[i],0,-4)
		Historia_HIS1.list[i].te2:Show()

		Historia_HIS1.list[i].F1 = Historia_HIS1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIS1.list[i].F1:SetPoint("BOTTOM",Historia_HIS1.list[i],0,4)
		Historia_HIS1.list[i].F1:SetText(cfg.Historia_HIS1_Text[i])
	end	
end


-------------------------------------------------------------------------------
--  Create the Skills (Class Skills) Achievements
-------------------------------------------------------------------------------
function Historia_HIS2_labels()
	local Historia_HIS2 = CreateFrame("FRAME", "Historia_HIS2", Historia_HA)
	Historia_HIS2:SetPoint("TOPLEFT","Historia_HIS1","BOTTOMLEFT",0,0)
	Historia_HIS2:SetPoint("BOTTOMRIGHT","Historia_HIS1",0,-46)

	Historia_HIS2.F1 = Historia_HIS2:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIS2.F1:SetPoint("LEFT" ,"Historia_HIS2", 8, 0)
	Historia_HIS2.F1:SetText(L["Class skills"] .. ":")	
				   
	Historia_HIS2.list = {}
	for i=1,cfg.Historia_HIS2_Buttons do
		Historia_HIS2.list[i] = CreateFrame("Button",nil,Historia_HIS2)
		Historia_HIS2.list[i]:SetSize(40,40)
		Historia_HIS2.list[i]:SetPoint("LEFT",Historia_HIS2,(i-1)*44+104, 0)
		Historia_HIS2.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIS2.list[i]:Show()
		Historia_HIS2.list[i].tooltip = 
			cfg.Historia_SetTooltip(Historia_HIS2.list[i], 
			L["HISTORIA_HIS2_1"] .. cfg.colors["Gold"] .. cfg.Historia_HIS2_Text[i] .. cfg.colors["End"] .. L["HISTORIA_HIS2_2"])	
		
		Historia_HIS2.list[i].te1 = Historia_HIS2.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIS2.list[i].te1:SetSize(20,20)
		Historia_HIS2.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIS2.list[i].te1:SetPoint("TOP",Historia_HIS2.list[i],0,-4)
		Historia_HIS2.list[i].te1:Hide()	
		
		Historia_HIS2.list[i].te2 = Historia_HIS2.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIS2.list[i].te2:SetSize(20,20)		
		Historia_HIS2.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIS2.list[i].te2:SetPoint("TOP",Historia_HIS2.list[i],0,-4)
		Historia_HIS2.list[i].te2:Show()

		Historia_HIS2.list[i].F1 = Historia_HIS2.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIS2.list[i].F1:SetPoint("BOTTOM",Historia_HIS2.list[i],0,4)
		Historia_HIS2.list[i].F1:SetText(cfg.Historia_HIS2_Text[i])
	end	
end


-------------------------------------------------------------------------------
--  Create the Quest Achievements
-------------------------------------------------------------------------------
function Historia_HIQ1_labels()
	local Historia_HIQ1 = CreateFrame("FRAME", "Historia_HIQ1", Historia_HA)
	Historia_HIQ1:SetPoint("TOPLEFT","Historia_HIS2","BOTTOMLEFT",0,0)
	Historia_HIQ1:SetPoint("BOTTOMRIGHT","Historia_HIS2",0,-46)

	Historia_HIQ1.F1 = Historia_HIQ1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIQ1.F1:SetPoint("LEFT" ,"Historia_HIQ1", 8, 0)
	Historia_HIQ1.F1:SetText(QUESTS_LABEL .. ":")	
				   
	Historia_HIQ1.list = {}
	for i=1,cfg.Historia_HIQ1_Buttons do
		Historia_HIQ1.list[i] = CreateFrame("Button",nil,Historia_HIQ1)
		Historia_HIQ1.list[i]:SetSize(40,40)
		Historia_HIQ1.list[i]:SetPoint("LEFT",Historia_HIQ1,(i-1)*44+104, 0)
		Historia_HIQ1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIQ1.list[i]:Show()
		Historia_HIQ1.list[i].tooltip = 
			cfg.Historia_SetTooltip(Historia_HIQ1.list[i], 
			L["HISTORIA_HIQ1_1"] .. cfg.colors["Orange Red"] .. cfg.Historia_HIQ1_Text[i] .. cfg.colors["End"] .. L["HISTORIA_HIQ1_2"])
		
		Historia_HIQ1.list[i].te1 = Historia_HIQ1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIQ1.list[i].te1:SetSize(20,20)
		Historia_HIQ1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIQ1.list[i].te1:SetPoint("TOP",Historia_HIQ1.list[i],0,-4)
		Historia_HIQ1.list[i].te1:Hide()	
		
		Historia_HIQ1.list[i].te2 = Historia_HIQ1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIQ1.list[i].te2:SetSize(20,20)		
		Historia_HIQ1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIQ1.list[i].te2:SetPoint("TOP",Historia_HIQ1.list[i],0,-4)
		Historia_HIQ1.list[i].te2:Show()

		Historia_HIQ1.list[i].F1 = Historia_HIQ1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIQ1.list[i].F1:SetPoint("BOTTOM",Historia_HIQ1.list[i],0,4)
		Historia_HIQ1.list[i].F1:SetText(cfg.Historia_HIQ1_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Create the number of Achievements
-------------------------------------------------------------------------------
function Historia_HIA1_labels()
	local Historia_HIA1 = CreateFrame("FRAME", "Historia_HIA1", Historia_HA)
	Historia_HIA1:SetPoint("TOPLEFT","Historia_HIQ1","BOTTOMLEFT",0,0)
	Historia_HIA1:SetPoint("BOTTOMRIGHT","Historia_HIQ1",0,-46)

	Historia_HIA1.F1 = Historia_HIA1:CreateFontString(nil, "ARTWORK", "GameFontWhite")
	Historia_HIA1.F1:SetPoint("LEFT" ,"Historia_HIA1", 8, 0)
	Historia_HIA1.F1:SetText(L["Achievements"] .. ":")	
				   
	Historia_HIA1.list = {}
	for i=1,Historia_HIA1_Buttons do
		Historia_HIA1.list[i] = CreateFrame("Button",nil,Historia_HIA1)
		Historia_HIA1.list[i]:SetSize(40,40)
		Historia_HIA1.list[i]:SetPoint("LEFT",Historia_HIA1,(i-1)*44+104, 0)
		Historia_HIA1.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HIA1.list[i]:Show()
		Historia_HIA1.list[i].tooltip = 
			cfg.Historia_SetTooltip(Historia_HIA1.list[i], 
			L["HISTORIA_HIA1_1"] .. cfg.colors["Sea green"] .. Historia_HIA1_Text[i] .. cfg.colors["End"] .. L["HISTORIA_HIA1_2"])		
		
		Historia_HIA1.list[i].te1 = Historia_HIA1.list[i]:CreateTexture(nil,"ARTWORK",nil,1)
		Historia_HIA1.list[i].te1:SetSize(20,20)
		Historia_HIA1.list[i].te1:SetTexture(cfg.CTX[2])			
		Historia_HIA1.list[i].te1:SetPoint("TOP",Historia_HIA1.list[i],0,-4)
		Historia_HIA1.list[i].te1:Hide()	
		
		Historia_HIA1.list[i].te2 = Historia_HIA1.list[i]:CreateTexture(nil,"ARTWORK",nil,2)
		Historia_HIA1.list[i].te2:SetSize(20,20)		
		Historia_HIA1.list[i].te2:SetTexture(cfg.CTX[3])			
		Historia_HIA1.list[i].te2:SetPoint("TOP",Historia_HIA1.list[i],0,-4)
		Historia_HIA1.list[i].te2:Show()

		Historia_HIA1.list[i].F1 = Historia_HIA1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HIA1.list[i].F1:SetPoint("BOTTOM",Historia_HIA1.list[i],0,4)
		Historia_HIA1.list[i].F1:SetText(Historia_HIA1_Text[i])		
	end	
end


-------------------------------------------------------------------------------
--  Determine how much gold you have earned
-------------------------------------------------------------------------------
--  For gold earned
local Best_day = -999999999

local Historia_NUMBER_OF_YEARS = 10
local Historia_NUMBER_OF_MONTHS = 12
local Historia_NUMBER_OF_DAYS = 31
local DTY = {"2015", "2016", "2017", "2018", "2019", "2020", "2021", "2022", "2023", "2024"}
local DTM = {"01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12"}
local DTD = {"01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31"}

local function updateAchievementsCurrency()
	for i = 1, Historia_NUMBER_OF_YEARS do
		if HistoriaLocalDb.Dates[DTY[i]] ~= nil then
			for j = 1, Historia_NUMBER_OF_MONTHS do
				if HistoriaLocalDb.Dates[DTY[i]][DTM[j]] ~= nil then
					for k = 1, Historia_NUMBER_OF_DAYS do
						if HistoriaLocalDb.Dates[DTY[i]][DTM[j]][DTD[k]] ~= nil then
							local amount_bwd = HistoriaLocalDb.Dates[DTY[i]][DTM[j]][DTD[k]].Gold_Current - HistoriaLocalDb.Dates[DTY[i]][DTM[j]][DTD[k]].Gold_Start
							if amount_bwd > Best_day then
								Best_day = amount_bwd
							end
						end
					end					
				end
			end 
		end	
	end	
end


-------------------------------------------------------------------------------
--  Count the ranks of your professions
-------------------------------------------------------------------------------
local function updateAchievementsProfessions()
	Professions_Tab = {}
	for i = 1, #cfg.PTX do
		local line = {}
		line[1] = cfg.PTX[i][1]
		line[2] = 0
		table.insert(Professions_Tab,line)
	end	
	
	for i = 1, #HistoriaLocalDb.Professions do
		if HistoriaLocalDb.Professions[i].kind == 2 then
			for j = 1, #Professions_Tab do
				if HistoriaLocalDb.Professions[i].name == Professions_Tab[j][1] then
					Professions_Tab[j][2] = HistoriaLocalDb.Professions[i].rank
				end
			end
		end
	end
end


-------------------------------------------------------------------------------
--  Decide if an professions achievement is met
-------------------------------------------------------------------------------
local function countAchievementsProfessions(number)
	counter = 0
	for i = 1, #Professions_Tab do
		if tonumber(Professions_Tab[i][2]) >= number then
			counter = counter + 1
		end
	end
	
	if counter >= Professions_Goal then
		return true
	else
		return false
	end	
end

-------------------------------------------------------------------------------
--  Count the ranks of your weapon skills
-------------------------------------------------------------------------------
local function updateAchievementsWeaponSkills()
	WeaponSkills_Tab = {}
	for i = 1, #cfg.WTX do
		local line = {}
		line[1] = cfg.WTX[i][1]
		line[2] = 0
		table.insert(WeaponSkills_Tab,line)
	end	
	
	for i = 1, #HistoriaLocalDb.Skills do
		if HistoriaLocalDb.Skills[i].kind == 1 then
			for j = 1, #WeaponSkills_Tab do
				if HistoriaLocalDb.Skills[i].name == WeaponSkills_Tab[j][1] then
					WeaponSkills_Tab[j][2] = HistoriaLocalDb.Skills[i].rank
				end
			end
		end
	end
end


-------------------------------------------------------------------------------
--  Decide if an weapons skill achievement is met
-------------------------------------------------------------------------------
local function countAchievementsWeaponSkills(number)
	counter = 0
	for i = 1, #WeaponSkills_Tab do
		if tonumber(WeaponSkills_Tab[i][2]) >= number then
			counter = counter + 1
		end
	end
	
	if counter >= WeaponSkills_Goal then
		return true
	else
		return false
	end	
end


-------------------------------------------------------------------------------
--	Show the correct Achievement
-------------------------------------------------------------------------------
function Historia_Show_Achievements()
	local Historia_HC = 0
	
	for i = 1, Historia_HIG1_Buttons do
		if HistoriaLocalDb.Enter_count >= Historia_HIG1_Text[i] then
			Historia_HIG1.list[i].te1:Show()	
			Historia_HIG1.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end	
	
	for i = 1, cfg.Historia_HIL1_Buttons do
		if #HistoriaLocalDb.Level >= cfg.Historia_HIL1_Text[i] then
			Historia_HIL1.list[i].te1:Show()	
			Historia_HIL1.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end	
	
	updateAchievementsCurrency()

	for i = 1, Historia_HIC1_Buttons do
		if Best_day >= Historia_HIC1_Text[i] then
			Historia_HIC1.list[i].te1:Show()	
			Historia_HIC1.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end		
	
	updateAchievementsProfessions()
	
	for i = 1, cfg.Historia_HIP1_Buttons do
		if countAchievementsProfessions(cfg.Historia_HIP1_Text[i]) then
			Historia_HIP1.list[i].te1:Show()	
			Historia_HIP1.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end		

	updateAchievementsWeaponSkills()
	
	for i = 1, cfg.Historia_HIS1_Buttons do
		if countAchievementsWeaponSkills(cfg.Historia_HIS1_Text[i]) then
			Historia_HIS1.list[i].te1:Show()	
			Historia_HIS1.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end	
	
	local ClassSkill_Goal = _G.UnitLevel("player") * 5
	
	for i = 1, cfg.Historia_HIS2_Buttons do
		if ClassSkill_Goal >= cfg.Historia_HIS2_Text[i] then
			Historia_HIS2.list[i].te1:Show()	
			Historia_HIS2.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end		

	for i = 1, cfg.Historia_HIQ1_Buttons do
		if #HistoriaLocalDb.Quests >= cfg.Historia_HIQ1_Text[i] then
			Historia_HIQ1.list[i].te1:Show()	
			Historia_HIQ1.list[i].te2:Hide()	
			Historia_HC = Historia_HC + 1
		end	
	end	

	for i = 1, Historia_HIA1_Buttons do
		if Historia_HC >= Historia_HIA1_Text[i] then
			Historia_HIA1.list[i].te1:Show()	
			Historia_HIA1.list[i].te2:Hide()	
		end	
	end	

	for i = 1, Historia_NUMBEROFRANKS do
		if Historia_HC >= Historia_HIA1_Text[i] then
			if cfg.PLAYER_FACTION == FACTION_ALLIANCE then
				Historia_HA_R.F2:SetText(Historia_Text_Alliance[i][1])
				Historia_HA_R.F3:SetText(Historia_Text_Alliance[i][2])
				Historia_HA_R.icon1:SetTexture(Historia_Logos_Alliance[i])
			else
				Historia_HA_R.F2:SetText(Historia_Text_Horde[i][1])
				Historia_HA_R.F3:SetText(Historia_Text_Horde[i][2])
				Historia_HA_R.icon1:SetTexture(Historia_Logos_Horde[i])	
			end	
		end
	end	
end


-------------------------------------------------------------------------------
--  Handle the Achievements Tab
-------------------------------------------------------------------------------
function Historia_HA_Update()
	Historia_Show_Achievements()
end
