--[[	*** Historia ***
Written by : Yukyuk, EU-Moonglade
--]]

-------------------------------------------------------------------------------
--  AddOn name space.
-------------------------------------------------------------------------------
local FOLDER_NAME, private = ...


-------------------------------------------------------------------------------
--  Libstubs.
-------------------------------------------------------------------------------
local L 		= LibStub("AceLocale-3.0"):GetLocale("Historia")


-------------------------------------------------------------------------------
--  Configuration table.
-------------------------------------------------------------------------------
local cfg 	= {}
private.cfg = cfg


-------------------------------------------------------------------------------
--  AddOn configuration constants.
-------------------------------------------------------------------------------
cfg.addon_name 			= "HistoriaClassic"
cfg.addon_version 		= "v1.3"	
cfg.ADDON_WIDTH = 866
cfg.ADDON_HEIGHT = 512
cfg.ADDON_YS = "0"
cfg.ADDON_MS = "0"
cfg.ADDON_DS = "0"


-------------------------------------------------------------------------------
--  Folder for the Icons.
-------------------------------------------------------------------------------
cfg.Icons = "Interface\\Addons\\HistoriaClassic\\Icons\\"


-------------------------------------------------------------------------------
--  Player constants.
-------------------------------------------------------------------------------
cfg.PLAYER_NAME		= _G.UnitName("player")
cfg.PLAYER_CLASS_DISPLAYNAME, cfg.PLAYER_CLASS, cfg.PLAYER_CLASS_ID = UnitClass("player")
cfg.PLAYER_FACTION 	= _G.UnitFactionGroup("player")
cfg.PLAYER_LEVEL 	= _G.UnitLevel("player")
cfg.PLAYER_GENDER 	= _G.UnitSex("player")
cfg.PLAYER_RACE		= _G.UnitRace("player")

if cfg.PLAYER_GENDER == 2 then
	cfg.PLAYER_GENDER_TEXT = MALE
else	
	cfg.PLAYER_GENDER_TEXT = FEMALE
end	

cfg.REALM_NAME 		= _G.GetRealmName()


-------------------------------------------------------------------------------
--  Default backdrops
-------------------------------------------------------------------------------
cfg.Historia_backdrop0 = {
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = false, tileSize = 8, edgeSize = 8,
	insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}	
	
cfg.Historia_backdrop1 = {
	bgFile = "Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-AchievementBackground",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = false, tileSize = 8, edgeSize = 8,
	insets = { left = 2, right = 2, top = 2, bottom = 2 }
	}
	
cfg.Historia_backdrop2 = {
	bgFile = "Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-Parchment-Horizontal-Desaturated",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = false, tileSize = 8, edgeSize = 8,
	insets = { left = 2, right = 2, top = 2, bottom = 2 }
	}	
	
cfg.Historia_backdrop3 = {
	bgFile = "Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-AchievementBackground",
	tile = false, tileSize = 8, edgeSize = 8,
	insets = { left = 2, right = 2, top = 2, bottom = 2 }
	}	
	
	
-------------------------------------------------------------------------------
--  Table  with the Currency textures.
-------------------------------------------------------------------------------
cfg.CTX = {
	"Interface\\COMMON\\Indicator-Gray",
	"Interface\\COMMON\\Indicator-Green",
	"Interface\\COMMON\\Indicator-Red",
	"Interface\\COMMON\\Indicator-Yellow",	
	}	
	
	
-------------------------------------------------------------------------------
--	Color table with HEX values
-------------------------------------------------------------------------------
cfg.colors = {
	["Gold"] = "\124cffFFD700",				-- Gold
	["Silver"] = "\124cffC0C0C0",			-- Silver
	["Light green"] = "\124cff90EE90",		-- Light Green
	["Chocolate"] = "\124cffD2691E",		-- Chocolate
	["Sea green"] = "\124cff2E8B57",		-- Sea Green
	["Orange Red"] = "\124cffFF4500",		-- Orange Red
	["Light steel blue"] = "\124cffB0C4DE",	-- Light Steel Blue		
	["Forest green"] = "\124cff228B22",		-- Forest Green
	["Copper"] = "\124cffB87333",			-- Copper
	["Platinum"] = "\124cffE5E4E2",			-- Platinum
	["End"] = "\124r",
	}
	
	
-------------------------------------------------------------------------------
--  Table  with the profession names and textures.
--	1 = Name (English)
--	2 = TextureId	
--	3 = Learned or not (by default false, used in the professions tab)
-------------------------------------------------------------------------------
cfg.PTX = {
	[1] = 	{[1] = L["Alchemy"],		[2] = 136240,[3] = false},
	[2] = 	{[1] = L["Blacksmithing"],	[2] = 136241,[3] = false},
	[3] = 	{[1] = L["Enchanting"],		[2] = 136244,[3] = false},
	[4] = 	{[1] = L["Engineering"],	[2] = 136243,[3] = false},	
	[5] = 	{[1] = L["Herbalism"],		[2] = 136246,[3] = false},	
	[6] = 	{[1] = L["Leatherworking"],	[2] = 136247,[3] = false},
	[7] = 	{[1] = L["Mining"],			[2] = 134708,[3] = false},
	[8] = 	{[1] = L["Skinning"],		[2] = 134366,[3] = false},
	[9] = 	{[1] = L["Tailoring"],		[2] = 136249,[3] = false},
	[10] = 	{[1] = L["Cooking"],		[2] = 133971,[3] = false},
	[11] = 	{[1] = L["First Aid"],		[2] = 135966,[3] = false},
	[12] = 	{[1] = L["Fishing"],		[2] = 136245,[3] = false},
	}	
	
-------------------------------------------------------------------------------
--  Table with the weapon skills names and textures (Including Defense).
--	1 = Name (English)
--	2 = TextureId	
--	3 = Learned or not (by default false, used in the skills tab)
--
--	While players must train to learn how to equip  Fist Weapons,
--	Fist Weapons do not teach a separate weapon skill and instead utilize the  Unarmed skill. 
--	In which case, players can level up their Unarmed skill by unequipping their weapon
--	and punching enemy monsters before they learn how to use a  Fist Weapons.
-------------------------------------------------------------------------------
cfg.WTX = {
	[1] = 	{[1] = L["Defense"],			[2] = 136047,[3] = false},
	[2] = 	{[1] = L["Two-Handed Axes"],	[2] = 132395,[3] = false},
	[3] = 	{[1] = L["Two-Handed Maces"],	[2] = 133479,[3] = false},
	[4] = 	{[1] = L["Two-Handed Swords"],	[2] = 132223,[3] = false},	
	[5] = 	{[1] = L["Axes"],				[2] = 132392,[3] = false},
	[6] = 	{[1] = L["Bows"],				[2] = 135493,[3] = false},
	[7] = 	{[1] = L["Crossbows"],			[2] = 135530,[3] = false},
	[8] = 	{[1] = L["Daggers"],			[2] = 132321,[3] = false},
	[9] = 	{[1] = L["Guns"],				[2] = 135610,[3] = false},
	[10] = 	{[1] = L["Maces"],				[2] = 133476,[3] = false},
	[11] = 	{[1] = L["Polearms"],			[2] = 135129,[3] = false},
	[12] = 	{[1] = L["Staves"],				[2] = 135145,[3] = false},
	[13] = 	{[1] = L["Swords"],				[2] = 132223,[3] = false},
	[14] = 	{[1] = L["Thrown"],				[2] = 135426,[3] = false},
	[15] = 	{[1] = L["Unarmed"],			[2] = 132154,[3] = false},
	[16] = 	{[1] = L["Wands"],				[2] = 132317,[3] = false},
	}


-------------------------------------------------------------------------------
--  Table with the class skills names and textures (Including Defense).
--	1 = Name (English)
--	2 = TextureId	
--	3 = Learned or not (by default false, used in the skills tab)
-------------------------------------------------------------------------------
cfg.TTX = {
	[1] = 	{[1] = L["Affliction"],		[2] = 136118,[3] = false},
	[2] = 	{[1] = L["Arcane"],			[2] = 136071,[3] = false},
	[3] = 	{[1] = L["Arms"],			[2] = 132282,[3] = false},
	[4] = 	{[1] = L["Assassination"],	[2] = 132298,[3] = false},
	[5] = 	{[1] = L["Balance"],		[2] = 136100,[3] = false},
	[6] = 	{[1] = L["Beast Mastery"],	[2] = 132179,[3] = false},
	[7] = 	{[1] = L["Combat"],			[2] = 132090,[3] = false},
	[8] = 	{[1] = L["Demonology"],		[2] = 136155,[3] = false},
	[9] = 	{[1] = L["Destruction"],	[2] = 135817,[3] = false},
	[10] = 	{[1] = L["Discipline"],		[2] = 135940,[3] = false},
	[11] = 	{[1] = L["Elemental Combat"],[2] = 136075,[3] = false},
	[12] = 	{[1] = L["Enhancement"],	[2] = 136148,[3] = false},
	[13] = 	{[1] = L["Feral Combat"],	[2] = 132121,[3] = false},
	[14] = 	{[1] = L["Fire"],			[2] = 135812,[3] = false},
	[15] = 	{[1] = L["Frost"],			[2] = 135857,[3] = false},
	[16] = 	{[1] = L["Fury"],			[2] = 132338,[3] = false},
	[17] = 	{[1] = L["Holy"],			[2] = 135928,[3] = false},
	[18] = 	{[1] = L["Marksmanship"],	[2] = 132369,[3] = false},
	[19] = 	{[1] = L["Protection"],		[2] = 132341,[3] = false},
	[20] = 	{[1] = L["Restoration"],	[2] = 136052,[3] = false},
	[21] = 	{[1] = L["Retribution"],	[2] = 135985,[3] = false},
	[22] = 	{[1] = L["Shadow"],			[2] = 135933,[3] = false},
	[23] = 	{[1] = L["Subtlety"],		[2] = 133644,[3] = false},
	[24] = 	{[1] = L["Survival"],		[2] = 132294,[3] = false},
	}
	
	
-------------------------------------------------------------------------------
--	Historia Achievement and Quest numbers 
--	Both used is several lua files so in cfg
-------------------------------------------------------------------------------	
cfg.Historia_HIL1_Buttons = 12
cfg.Historia_HIP1_Buttons = 12
cfg.Historia_HIS1_Buttons = 12
cfg.Historia_HIS2_Buttons = 12
cfg.Historia_HIQ1_Buttons = 12
cfg.Historia_HIL1_Text = {5,10,15,20,25,30,35,40,45,50,55,60}
cfg.Historia_HIP1_Text = {25,50,75,100,125,150,175,200,225,250,275,300}
cfg.Historia_HIS1_Text = {25,50,75,100,125,150,175,200,225,250,275,300}
cfg.Historia_HIS2_Text = {25,50,75,100,125,150,175,200,225,250,275,300}	
cfg.Historia_HIQ1_Text = {10,20,30,40,50,75,100,125,150,175,200,250}


-------------------------------------------------------------------------------	
--  Table to transform a month number into a month name.
-------------------------------------------------------------------------------
cfg.Historia_month_table = {FULLDATE_MONTH_JANUARY, 
						FULLDATE_MONTH_FEBRUARY, 
						FULLDATE_MONTH_MARCH, 
						FULLDATE_MONTH_APRIL, 
						FULLDATE_MONTH_MAY,
						FULLDATE_MONTH_JUNE,
						FULLDATE_MONTH_JULY,
						FULLDATE_MONTH_AUGUST,
						FULLDATE_MONTH_SEPTEMBER,
						FULLDATE_MONTH_OCTOBER,
						FULLDATE_MONTH_NOVEMBER,
						FULLDATE_MONTH_DECEMBER
						}

						
--  Format the date(s) to a readable form
cfg.Historia_FormatDate = function(year, month, day)
	local DF_year = year
	local DF_month = month
	local DF_day = day
	local date_string
	
	if day == "" then
		date_string = format(cfg.Historia_month_table[tonumber(DF_month)] .. " " .. year)
	else
		date_string = format(cfg.Historia_month_table[tonumber(DF_month)] .. " " .. day .. " " .. year)
	end	

	return date_string
end	


--------------------------------------------------------------------------------
--  Button factory for Hievements tab tool tips
--------------------------------------------------------------------------------
cfg.Historia_Button_OnEnter = function(self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT", 0, -8)
	GameTooltip:SetText(self.tooltipText, nil, nil, nil, nil, true)
	GameTooltip:Show()
end


cfg.Historia_Button_OnLeave = function()
	GameTooltip_Hide()
end


--  If text is provided, sets up the button to show a tool tip when moused over. Otherwise, removes the tool tip.
cfg.Historia_SetTooltip = function(self, text)
	if text then
		self.tooltipText = text
		self:SetScript("OnEnter", cfg.Historia_Button_OnEnter)
		self:SetScript("OnLeave", cfg.Historia_Button_OnLeave)
	else
		self:SetScript("OnEnter", nil)
		self:SetScript("OnLeave", nil)
	end
end
