--[[	*** Historia ***
Written by : Yukyuk, EU-Moonglade
--]]

-------------------------------------------------------------------------------
--  From _Global to local.
-------------------------------------------------------------------------------
local _G = _G


-------------------------------------------------------------------------------
--  AddOn namespace.
-------------------------------------------------------------------------------
local FOLDER_NAME, private = ...

local cfg = private.cfg
local addon = cfg.addon_name


-------------------------------------------------------------------------------
--  Libstubs.
-------------------------------------------------------------------------------
local L 		= LibStub("AceLocale-3.0"):GetLocale("Historia")
local LibQTip 	= LibStub:GetLibrary("LibQTip-1.0")


--------------------------------------------------------------------------------
--  This is the Historia main frame
--------------------------------------------------------------------------------	
function Historia_Main_Frame()
	local Historia_HM = CreateFrame("Frame","Historia_HM",Historia_UI)
	Historia_HM:SetPoint("TOP","Historia_UI",0,-16)
	Historia_HM:SetPoint("BOTTOM","Historia_UI",0,16)
	Historia_HM:SetPoint("LEFT","Historia_UI",16,0)
	Historia_HM:SetPoint("RIGHT","Historia_UI",-16,0)
	Historia_HM:SetBackdrop(cfg.Historia_backdrop3)

	local Historia_HM_H = CreateFrame("Frame","Historia_HM_H",Historia_HM)
	Historia_HM_H:SetPoint("TOPLEFT","Historia_HM",0,0)
	Historia_HM_H:SetPoint("BOTTOMRIGHT","Historia_HM","TOPRIGHT",0,-48)
	Historia_HM_H:SetBackdrop(cfg.Historia_backdrop2)	
	
	Historia_HM_H.F1 = Historia_HM_H:CreateFontString(nil,"ARTWORK","GameFontNormalHuge")
	Historia_HM_H.F1:SetPoint("CENTER","Historia_HM_H",0,0)
	Historia_HM_H.F1:SetText(L["History of:"] .. " " .. cfg.PLAYER_NAME)
	
	Historia_Main_Frame_TopLeft()
	Historia_Main_Frame_TopRight()
	Historia_Main_Frame_TopMiddle()	
	
	Historia_Main_Frame_BottomLeft()
	Historia_Main_Frame_BottomRight()	
	Historia_Main_Frame_BottomMiddle()		
	
	Historia_HM:Hide()
end	


--------------------------------------------------------------------------------
--  This is the Historia main frame, the TopLeft part
--------------------------------------------------------------------------------	
function Historia_Main_Frame_TopLeft()
	local Historia_HM_I = CreateFrame("Frame","Historia_HM_I",Historia_HM)
	Historia_HM_I:SetPoint("TOPLEFT","Historia_HM_H","BOTTOMLEFT",0,-16)
	Historia_HM_I:SetPoint("BOTTOMRIGHT","Historia_HM_H","BOTTOMLEFT",320,-248)
	Historia_HM_I:SetBackdrop(cfg.Historia_backdrop2)	
	local Historia_HM_I_Width = Historia_HM_I:GetWidth()	
	local Historia_HM_I_Height = Historia_HM_I:GetHeight()

	local Historia_HM_IL = CreateFrame("Frame","Historia_HM_IL",Historia_HM_I)
	Historia_HM_IL:SetPoint("TOPLEFT","Historia_HM_I",0,0)
	Historia_HM_IL:SetPoint("BOTTOMRIGHT","Historia_HM_I","TOPLEFT",Historia_HM_I_Width*0.5,Historia_HM_I_Height*-1)
	
	Historia_HM_IL.F0 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_IL.F0:SetPoint("TOP","Historia_HM_I",0,-4)
	Historia_HM_IL.F0:SetText(GENERAL)
	
	Historia_HM_IL.F1 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_IL.F1:SetPoint("TOP","Historia_HM_IL",0,-16)
	Historia_HM_IL.F1:SetText(NAME)	
		
	Historia_HM_IL.F2 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_IL.F2:SetPoint("TOP","Historia_HM_IL",0,-32)
	Historia_HM_IL.F2:SetText(cfg.PLAYER_NAME)		
		
	Historia_HM_IL.F3 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_IL.F3:SetPoint("TOP","Historia_HM_IL",0,-48)
	Historia_HM_IL.F3:SetText(L["Gender"])	
		
	Historia_HM_IL.F4 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_IL.F4:SetPoint("TOP","Historia_HM_IL",0,-64)
	Historia_HM_IL.F4:SetText(cfg.PLAYER_GENDER_TEXT)	
		
	Historia_HM_IL.F5 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_IL.F5:SetPoint("TOP","Historia_HM_IL",0,-80)
	Historia_HM_IL.F5:SetText(RACE)		
	
	Historia_HM_IL.F6 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_IL.F6:SetPoint("TOP","Historia_HM_IL",0,-96)
	Historia_HM_IL.F6:SetText(cfg.PLAYER_RACE)

	Historia_HM_IL.F7 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_IL.F7:SetPoint("TOP","Historia_HM_IL",0,-128)
	Historia_HM_IL.F7:SetText(CLASS)
	
	Historia_HM_IL.F8 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_IL.F8:SetPoint("TOP","Historia_HM_IL",0,-144)
	Historia_HM_IL.F8:SetText(cfg.PLAYER_CLASS_DISPLAYNAME)	
	
	Historia_HM_IL.F9 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_IL.F9:SetPoint("TOP","Historia_HM_IL",0,-160)
	Historia_HM_IL.F9:SetText(FRIENDS_LIST_REALM)		
	
	Historia_HM_IL.F10 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_IL.F10:SetPoint("TOP","Historia_HM_IL",0,-176)
	Historia_HM_IL.F10:SetText(cfg.REALM_NAME)

	Historia_HM_IL.F11 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_IL.F11:SetPoint("TOP","Historia_HM_IL",0,-192)
	Historia_HM_IL.F11:SetText(LEVEL)	
	
	Historia_HM_IL.F12 = Historia_HM_IL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_IL.F12:SetPoint("TOP","Historia_HM_IL",0,-208)	

	local Historia_HM_IR = CreateFrame("Frame","Historia_HM_IR",Historia_HM_I)
	Historia_HM_IR:SetPoint("TOPLEFT","Historia_HM_I",Historia_HM_I_Width*0.5,0)
	Historia_HM_IR:SetPoint("BOTTOMRIGHT","Historia_HM_I","TOPLEFT",Historia_HM_I_Width,Historia_HM_I_Height*-1)

	local Historia_CH = CreateFrame("Frame","Historia_CH",Historia_HM_IR)
	Historia_CH:SetAllPoints()
	Historia_CH:Show()

	Historia_CH.playermodel = CreateFrame("PlayerModel",nil,Historia_CH)
	Historia_CH.playermodel:SetSize(200,200)
	Historia_CH.playermodel:SetPoint("CENTER")	
	Historia_CH.playermodel:SetRotation(math.rad(0))
	Historia_CH.playermodel:SetCamDistanceScale(1)
	Historia_CH.playermodel:SetPosition(0,0,0)	
	Historia_CH.playermodel:SetLight(true, false, 0, -0.707, -0.707, 0.7, 1.0, 1.0, 1.0, 0.8, 1.0, 1.0, 0.8)
end


--------------------------------------------------------------------------------
--  This is the Historia main frame, the TopRight part
--------------------------------------------------------------------------------	
function Historia_Main_Frame_TopRight()
	local Historia_HM_J = CreateFrame("Frame","Historia_HM_J",Historia_HM)
	Historia_HM_J:SetPoint("TOPRIGHT","Historia_HM_H","BOTTOMRIGHT",0,-16)
	Historia_HM_J:SetPoint("BOTTOMLEFT","Historia_HM_H","BOTTOMRIGHT",-320,-248)
	Historia_HM_J:SetBackdrop(cfg.Historia_backdrop2)	
	local Historia_HM_J_Width = Historia_HM_J:GetWidth()	
	local Historia_HM_J_Height = Historia_HM_J:GetHeight()
	
	local Historia_HM_JL = CreateFrame("Frame","Historia_HM_JL",Historia_HM_J)
	Historia_HM_JL:SetPoint("TOPLEFT","Historia_HM_J",0,0)
	Historia_HM_JL:SetPoint("BOTTOMRIGHT","Historia_HM_J","TOPLEFT",Historia_HM_J_Width*0.5,Historia_HM_J_Height*-1)
	
	Historia_HM_JL.F0 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JL.F0:SetPoint("TOP","Historia_HM_J",0,-4)
	Historia_HM_JL.F0:SetText(L["Recorded"])	
	
	Historia_HM_JL.F1 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JL.F1:SetPoint("TOP","Historia_HM_JL",0,-16)
	Historia_HM_JL.F1:SetText(L["Levels"])	
	
	Historia_HM_JL.F2 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_JL.F2:SetPoint("TOP","Historia_HM_JL",0,-32)
	
	Historia_HM_JL.F3 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JL.F3:SetPoint("TOP","Historia_HM_JL",0,-48)
	Historia_HM_JL.F3:SetText(L["First"])

	Historia_HM_JL.F4 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_JL.F4:SetPoint("TOP","Historia_HM_JL",0,-64)	
	
	Historia_HM_JL.F5 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JL.F5:SetPoint("TOP","Historia_HM_JL",0,-80)
	Historia_HM_JL.F5:SetText(L["Latest"])

	Historia_HM_JL.F6 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_JL.F6:SetPoint("TOP","Historia_HM_JL",0,-96)	
	
	Historia_HM_JL.F7 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JL.F7:SetPoint("TOP","Historia_HM_JL",0,-128)
	Historia_HM_JL.F7:SetText(SKILLS)	
	
	Historia_HM_JL.F8 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_JL.F8:SetPoint("TOP","Historia_HM_JL",0,-144)
	
	Historia_HM_JL.F9 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JL.F9:SetPoint("TOP","Historia_HM_JL",0,-160)
	Historia_HM_JL.F9:SetText(L["First"])

	Historia_HM_JL.F10 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_JL.F10:SetPoint("TOP","Historia_HM_JL",0,-176)	
	
	Historia_HM_JL.F11 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JL.F11:SetPoint("TOP","Historia_HM_JL",0,-192)
	Historia_HM_JL.F11:SetText(L["Latest"])

	Historia_HM_JL.F12 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_JL.F12:SetPoint("TOP","Historia_HM_JL",0,-208)		

	local Historia_HM_JR = CreateFrame("Frame","Historia_HM_JR",Historia_HM_J)
	Historia_HM_JR:SetPoint("TOPLEFT","Historia_HM_J",Historia_HM_J_Width*0.5,0)
	Historia_HM_JR:SetPoint("BOTTOMRIGHT","Historia_HM_J","TOPLEFT",Historia_HM_J_Width,Historia_HM_J_Height*-1)	

	Historia_HM_JR.F1 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JR.F1:SetPoint("TOP","Historia_HM_JR",0,-16)
	Historia_HM_JR.F1:SetText(TUTORIAL_TITLE38)	

	Historia_HM_JR.F2 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_JR.F2:SetPoint("TOP","Historia_HM_JR",0,-32)
	
	Historia_HM_JR.F3 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JR.F3:SetPoint("TOP","Historia_HM_JR",0,-48)
	Historia_HM_JR.F3:SetText(L["First"])	

	Historia_HM_JR.F4 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_JR.F4:SetPoint("TOP","Historia_HM_JR",0,-64)

	Historia_HM_JR.F5 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JR.F5:SetPoint("TOP","Historia_HM_JR",0,-80)
	Historia_HM_JR.F5:SetText(L["Latest"])

	Historia_HM_JR.F6 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_JR.F6:SetPoint("TOP","Historia_HM_JR",0,-96)	

	Historia_HM_JR.F7 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JR.F7:SetPoint("TOP","Historia_HM_JR",0,-128)
	Historia_HM_JR.F7:SetText(QUESTS_LABEL)	

	Historia_HM_JR.F8 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_JR.F8:SetPoint("TOP","Historia_HM_JR",0,-144)
	
	Historia_HM_JR.F9 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JR.F9:SetPoint("TOP","Historia_HM_JR",0,-160)
	Historia_HM_JR.F9:SetText(L["First"])	

	Historia_HM_JR.F10 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_JR.F10:SetPoint("TOP","Historia_HM_JR",0,-176)

	Historia_HM_JR.F11 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_JR.F11:SetPoint("TOP","Historia_HM_JR",0,-192)
	Historia_HM_JR.F11:SetText(L["Latest"])

	Historia_HM_JR.F12 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_JR.F12:SetPoint("TOP","Historia_HM_JR",0,-208)	
end


--------------------------------------------------------------------------------
--  This is the Historia main frame, the TopMiddle part
--------------------------------------------------------------------------------	
function Historia_Main_Frame_TopMiddle()
	local Historia_HM_TM = CreateFrame("Frame","Historia_HM_TM",Historia_HM)
	Historia_HM_TM:SetPoint("TOPLEFT","Historia_HM_I","TOPRIGHT",16,0)
	Historia_HM_TM:SetPoint("BOTTOMRIGHT","Historia_HM_J","BOTTOMLEFT",-16,0)
	Historia_HM_TM:SetBackdrop(cfg.Historia_backdrop2)	
	
	local Historia_HM_TM_T1 = Historia_HM_TM:CreateTexture(nil,"ARTWORK")
	Historia_HM_TM_T1:SetPoint("TOPLEFT", Historia_HM_TM, 4, -4); 
	Historia_HM_TM_T1:SetPoint("BOTTOMRIGHT", Historia_HM_TM, -4, 4)	
	
	--  Fill the faction banner.	
	if cfg.PLAYER_FACTION == "Neutral" then
		Historia_HM_TM_T1:SetTexture("Interface\\Timer\\Challenges-Logo")	
	else
		Historia_HM_TM_T1:SetTexture("Interface\\Timer\\"..cfg.PLAYER_FACTION.."-Logo")
	end
end


--------------------------------------------------------------------------------
--  This is the Historia main frame, the BottomLeft part
--------------------------------------------------------------------------------	
function Historia_Main_Frame_BottomLeft()
	local Historia_HM_K = CreateFrame("Frame","Historia_HM_K",Historia_HM)
	Historia_HM_K:SetPoint("BOTTOMLEFT","Historia_HM","BOTTOMLEFT",0,0)
	Historia_HM_K:SetPoint("TOPRIGHT","Historia_HM_I","BOTTOMRIGHT",0,-16)
	Historia_HM_K:SetBackdrop(cfg.Historia_backdrop2)	
	
	Historia_HM_K.F1 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_K.F1:SetPoint("TOP","Historia_HM_K",0,-16)	
	Historia_HM_K.F1:SetText(cfg.PLAYER_NAME)	
	
	Historia_HM_K.F2 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_K.F2:SetPoint("TOP","Historia_HM_K",0,-32)	
	Historia_HM_K.F2:SetText(L["Has entered the world of Historia"])
	
	Historia_HM_K.F4 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_K.F4:SetPoint("TOP","Historia_HM_K",0,-48)	
	
	Historia_HM_K.F5 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_K.F5:SetPoint("TOP","Historia_HM_K",0,-64)	
	Historia_HM_K.F5:SetText(L["times."])	
	
	Historia_HM_K.F6 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_K.F6:SetPoint("TOP","Historia_HM_K",0,-96)	
	Historia_HM_K.F6:SetText(cfg.PLAYER_NAME)	

	Historia_HM_K.F7 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_K.F7:SetPoint("TOP","Historia_HM_K",0,-112)	
	Historia_HM_K.F7:SetText(L["Has entered the world of Historia"])	

	Historia_HM_K.F8 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_K.F8:SetPoint("TOP","Historia_HM_K",0,-128)	
	Historia_HM_K.F8:SetText(L["for the first time on:"])	

	Historia_HM_K.F9 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_K.F9:SetPoint("TOP","Historia_HM_K",0,-144)	
	Historia_HM_K.F9:SetText(format(date("%a, %b %d %Y %H:%M", HistoriaLocalDb.Database_build)))		
end


--------------------------------------------------------------------------------
--  This is the Historia main frame, the BottomLeft part
--------------------------------------------------------------------------------	
function Historia_Main_Frame_BottomRight()
	local Historia_HM_L = CreateFrame("Frame","Historia_HM_L",Historia_HM)
	Historia_HM_L:SetPoint("BOTTOMRIGHT","Historia_HM","BOTTOMRIGHT",0,0)
	Historia_HM_L:SetPoint("TOPLEFT","Historia_HM_J","BOTTOMLEFT",0,-16)
	Historia_HM_L:SetBackdrop(cfg.Historia_backdrop2)	
	
	Historia_HM_L.F1 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_L.F1:SetPoint("TOP","Historia_HM_L",0,-16)	
	Historia_HM_L.F1:SetText(L["All your characters combined,"])	
	
	Historia_HM_L.F2 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_L.F2:SetPoint("TOP","Historia_HM_L",0,-32)	
	Historia_HM_L.F2:SetText(L["have entered the world of"])

	Historia_HM_L.F3 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_L.F3:SetPoint("TOP","Historia_HM_L",0,-48)	
	Historia_HM_L.F3:SetText(L["Historia"])	
	
	Historia_HM_L.F4 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HM_L.F4:SetPoint("TOP","Historia_HM_L",0,-64)	
	
	Historia_HM_L.F5 = Historia_HM_JL:CreateFontString(nil,"ARTWORK","GameFontNormal")
	Historia_HM_L.F5:SetPoint("TOP","Historia_HM_L",0,-80)	
	Historia_HM_L.F5:SetText(L["times."])		
end


--------------------------------------------------------------------------------
--  This is the Historia main frame, the BottomMiddle part
--------------------------------------------------------------------------------	
function Historia_Main_Frame_BottomMiddle()
	local Historia_HM_BM = CreateFrame("Frame","Historia_HM_BM",Historia_HM)
	Historia_HM_BM:SetPoint("TOPLEFT","Historia_HM_K","TOPRIGHT",16,0)
	Historia_HM_BM:SetPoint("BOTTOMRIGHT","Historia_HM_L","BOTTOMLEFT",-16,0)
	Historia_HM_BM:SetBackdrop(cfg.Historia_backdrop2)	
	
	Historia_HM_BM.TabardBorder = Historia_HM_BM:CreateTexture(nil,"ARTWORK",nil,1)
	Historia_HM_BM.TabardBorder:SetAllPoints()
	Historia_HM_BM.TabardBorder:SetTexture("Interface\\CHARACTERFRAME\\TempPortraitAlphaMask")
	Historia_HM_BM.TabardBorder:SetPoint("TOPLEFT", Historia_HM_BM, 32, -32)
	Historia_HM_BM.TabardBorder:SetPoint("BOTTOMRIGHT", Historia_HM_BM, -32, 32)
	Historia_HM_BM.TabardBorder:SetAlpha(1.0)	

	Historia_HM_BM.TabardBackground = Historia_HM_BM:CreateTexture(nil,"ARTWORK",nil,2)
	Historia_HM_BM.TabardBackground:SetAllPoints()
	Historia_HM_BM.TabardBackground:SetTexture("Interface\\CHARACTERFRAME\\TempPortraitAlphaMask")
	Historia_HM_BM.TabardBackground:SetPoint("TOPLEFT", Historia_HM_BM, 36, -36)
	Historia_HM_BM.TabardBackground:SetPoint("BOTTOMRIGHT", Historia_HM_BM, -36, 36)
	Historia_HM_BM.TabardBackground:SetAlpha(1.0)
	
	Historia_HM_BM.TabardEmblem = Historia_HM_BM:CreateTexture(nil,"ARTWORK",nil,3)
	Historia_HM_BM.TabardEmblem:SetAllPoints()
	Historia_HM_BM.TabardEmblem:SetTexture("Interface\\GuildFrame\\GuildEmblemsLG_01")
	Historia_HM_BM.TabardEmblem:SetPoint("TOPLEFT", Historia_HM_BM, 38, -38)
	Historia_HM_BM.TabardEmblem:SetPoint("BOTTOMRIGHT", Historia_HM_BM, -38, 38)
	Historia_HM_BM.TabardEmblem:SetAlpha(1.0)	
end


-------------------------------------------------------------------------------
-- Update the Mainframe
-------------------------------------------------------------------------------
function Historia_Mainframe_Update()
	Historia_HM_IL.F12:SetText(_G.UnitLevel("player"))
	
	Historia_CH.playermodel:SetUnit("player")	
	Historia_CH.playermodel:SetAnimation(66)	--	Bow	
	Historia_CH.playermodel:Show()	
	
	Historia_HM_JL.F2:SetText(#HistoriaLocalDb.Level)
	Historia_HM_JL.F4:SetText(format(date("%b %d %Y %H:%M", HistoriaLocalDb.Level[1].time)))
	Historia_HM_JL.F6:SetText(format(date("%b %d %Y %H:%M", HistoriaLocalDb.Level[#HistoriaLocalDb.Level].time)))	
	
	Historia_HM_JR.F2:SetText(#HistoriaLocalDb.Professions)
	if #HistoriaLocalDb.Professions ~= 0 then
		Historia_HM_JR.F4:SetText(format(date("%b %d %Y %H:%M", HistoriaLocalDb.Professions[1].time)))
		Historia_HM_JR.F6:SetText(format(date("%b %d %Y %H:%M", HistoriaLocalDb.Professions[#HistoriaLocalDb.Professions].time)))
	end		
	
	Historia_HM_JL.F8:SetText(#HistoriaLocalDb.Skills)
	if #HistoriaLocalDb.Skills ~= 0 then
		Historia_HM_JL.F10:SetText(format(date("%b %d %Y %H:%M", HistoriaLocalDb.Skills[1].time)))
		Historia_HM_JL.F12:SetText(format(date("%b %d %Y %H:%M", HistoriaLocalDb.Skills[#HistoriaLocalDb.Skills].time)))	
	end	
	
	Historia_HM_JR.F8:SetText(#HistoriaLocalDb.Quests)
	if #HistoriaLocalDb.Quests ~= 0 then
		Historia_HM_JR.F10:SetText(format(date("%b %d %Y %H:%M", HistoriaLocalDb.Quests[1].time)))
		Historia_HM_JR.F12:SetText(format(date("%b %d %Y %H:%M", HistoriaLocalDb.Quests[#HistoriaLocalDb.Quests].time)))
	end		

	Historia_HM_K.F4:SetText(HistoriaLocalDb.Enter_count)	
	Historia_HM_L.F4:SetText(HistoriaGlobalDb.Enter_count)	

	SetLargeGuildTabardTextures("player", Historia_HM_BM.TabardEmblem, Historia_HM_BM.TabardBackground, Historia_HM_BM.TabardBorder)	
end
