--[[	*** Historia ***
Written by : Yukyuk, EU-Moonglade
--]]

-------------------------------------------------------------------------------
--  From _Global to local.
-------------------------------------------------------------------------------
local _G = _G


-------------------------------------------------------------------------------
--  AddOn namespace.
-------------------------------------------------------------------------------
local FOLDER_NAME, private = ...

local cfg = private.cfg
local addon = cfg.addon_name


-------------------------------------------------------------------------------
--  Libstubs.
-------------------------------------------------------------------------------
local L 				= LibStub("AceLocale-3.0"):GetLocale("Historia")
local LibQTip 			= LibStub:GetLibrary("LibQTip-1.0")


-------------------------------------------------------------------------------
--	Local constants
-------------------------------------------------------------------------------
local row_count = 0
local Historia_HS_NO_SCROLLBUTTONS = 24	--  number of scroll buttons for the Skills frame
local Historia_NUMBEROFSKILLSTABS = 18	--	number of selection buttons in the Skills tab
local Historia_Skills_Tab = {}			--	this variable holds the selection buttons
local Historia_Skills_Table = {}		--	this variable holds the Skills dates selected from the database
local Historia_Skills_Scroll_Table = {}	--	this variable holds the selected lines that go into the scroll table
local Historia_Skill_Tabs = {}			--	this table holds the (shown) SkillId's 

--  Define the initial icon of the Skills tab .
 local Skills_icon = {
	[1] = "Interface\\ICONS\\INV_Misc_QuestionMark",
}


--------------------------------------------------------------------------------
--  This is the Historia Skills frame
--------------------------------------------------------------------------------	
function Historia_Skills()
	local Historia_HS = CreateFrame("Frame","Historia_HS",Historia_UI)
	Historia_HS:SetID(1)
	Historia_HS:SetPoint("TOP", "Historia_UI", 0, -16)
	Historia_HS:SetPoint("BOTTOM", "Historia_UI", 0, 16)
	Historia_HS:SetPoint("LEFT", "Historia_UI", 16, 0)
	Historia_HS:SetPoint("RIGHT", "Historia_UI", -16, 0)
	Historia_HS:SetBackdrop(cfg.Historia_backdrop3)
	
	--  Create a frame for the header Skills info.
	local Historia_HS_H = CreateFrame("Frame","Historia_HS_H",Historia_HS)
	Historia_HS_H:SetPoint("TOPLEFT","Historia_HS",0,0)
	Historia_HS_H:SetPoint("BOTTOMRIGHT","Historia_HS","TOPRIGHT",0,-48)
	Historia_HS_H:SetBackdrop(cfg.Historia_backdrop2)	
	
	Historia_HS_H.F1 = Historia_HS_H:CreateFontString(nil,"ARTWORK","GameFontNormalHuge")
	Historia_HS_H.F1:SetPoint("CENTER","Historia_HS_H",0,0)
	Historia_HS_H.F1:SetText(L["History of:"] .. " " .. SKILLS)	
	
	Historia_Skills_Scrollframe()
	Historia_Skills_TheRest()

	Historia_HS:Hide()
end	


-------------------------------------------------------------------------------
--  Fill the Skills scroll table
-------------------------------------------------------------------------------
function Historia_Skills_Scrollframe()
	--  Create a reference frame for the rest of the Skills info.
	local Historia_HS_I = CreateFrame("Frame","Historia_HS_I",Historia_HS)
	Historia_HS_I:SetPoint("TOPLEFT", "Historia_HS_H", "BOTTOMLEFT", 0, -16)
	Historia_HS_I:SetPoint("BOTTOMRIGHT", "Historia_HS", "BOTTOMRIGHT", 0, 0)
	local Historia_HS_I_Width = Historia_HS_I:GetWidth()	
	local Historia_HS_I_Height = Historia_HS_I:GetHeight()
	-- print(Historia_HS_I_Width)
	-- print(Historia_HS_I_Height)

	--  Create a frame for the header Skills text.
	local Historia_HS_IH = CreateFrame("Frame","Historia_HS_IH",Historia_HS_I)
	Historia_HS_IH:SetPoint("TOPLEFT","Historia_HS_I",0,0)
	Historia_HS_IH:SetPoint("BOTTOMRIGHT","Historia_HS_I","TOPLEFT",320,-24)
	Historia_HS_IH:SetBackdrop(cfg.Historia_backdrop2)	
	
	Historia_HS_IH.F1 = Historia_HS_IH:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HS_IH.F1:SetPoint("CENTER","Historia_HS_IH",0,0)
	Historia_HS_IH.F1:SetText("")	
	
	--  Create the container for the Skills scroll frame.
	local HSSF1 = CreateFrame("Frame","HSSF1",Historia_HS_I)
	HSSF1:SetPoint("TOPLEFT", "Historia_HS_I", "TOPLEFT", 0, -24)
	HSSF1:SetPoint("BOTTOMRIGHT", "Historia_HS_I", "TOPLEFT", 320, Historia_HS_I_Height*-1)
	HSSF1:SetBackdrop((cfg.Historia_backdrop2))

	--  Create the container for the Skills scroll bar.
	local HSSF1_bar = CreateFrame("Frame","HSSF1_bar",HSSF1)
	HSSF1_bar:SetPoint("TOPRIGHT", "HSSF1", 0, 0)
	HSSF1_bar:SetPoint("BOTTOMLEFT", "HSSF1", "BOTTOMRIGHT", -24, 0)
	HSSF1_bar:SetBackdrop(cfg.Historia_backdrop2)	

	--  Create the list of buttons that go into the Skills scroll frame
	HSSF1.list = {}
	for i=1,Historia_HS_NO_SCROLLBUTTONS do
		HSSF1.list[i] = CreateFrame("Button",nil,HSSF1)
		HSSF1.list[i]:SetSize(320,16)
		HSSF1.list[i]:SetPoint("TOPLEFT",HSSF1,"TOPLEFT",8,(i-1)*-16-4)
		HSSF1.list[i]:Show()
		
		HSSF1.list[i].name1 = HSSF1.list[i]:CreateFontString(nil,"ARTWORK","GameFontWhite")
		HSSF1.list[i].name1:SetSize(160,16)
		HSSF1.list[i].name1:SetPoint("LEFT",0,0)	
		HSSF1.list[i].name1:SetJustifyH("LEFT") 

		HSSF1.list[i].name2 = HSSF1.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		HSSF1.list[i].name2:SetSize(32,16)
		HSSF1.list[i].name2:SetPoint("LEFT", HSSF1.list[i].name1, "RIGHT",4,0)
		HSSF1.list[i].name2:SetJustifyH("LEFT") 
	end	
	
	-- 	Create the scroll frame
	HSSF1.scrollFrame = CreateFrame("ScrollFrame","HSSF1_scrollFrame",HSSF1,"FauxScrollFrameTemplate")
	HSSF1.scrollFrame:SetPoint("TOPLEFT",HSSF1,"TOPLEFT",0,-2)
	HSSF1.scrollFrame:SetPoint("BOTTOMRIGHT",HSSF1,"BOTTOMRIGHT",-26,2)
	HSSF1.scrollFrame:SetScript("OnVerticalScroll",function(self,offset)
	FauxScrollFrame_OnVerticalScroll(self,offset,16,HSSF1_ScrollFrameUpdate)
	end)	
	
		--	Create the Skills buttons
	for i = 1,Historia_NUMBEROFSKILLSTABS do
		Historia_Skills_Tab[i] = CreateFrame("Button",nil,Historia_HS_I)
		Historia_Skills_Tab[i]:SetSize(40,40)
		if i <= 9 then
			Historia_Skills_Tab[i]:SetPoint("TOPLEFT",HSSF1,"TOPRIGHT",0,(i-1)*-40)
		else
			Historia_Skills_Tab[i]:SetPoint("TOPLEFT",HSSF1,"TOPRIGHT",40,(i-10)*-40)		
		end	
		Historia_Skills_Tab[i]:SetBackdrop(cfg.Historia_backdrop0)
		Historia_Skills_Tab[i]:Show()
		Historia_Skills_Tab[i]:SetScript("OnClick", function(self, button)
			Historia_HS_Build_Table(i)		
		end)	
		Historia_Skills_Tab[i]:SetScript("OnEnter", function(self, button)
			Historia_Skills_Tab[i].te1:Show()
		end)		
		Historia_Skills_Tab[i]:SetScript("OnLeave", function(self, button)
			Historia_Skills_Tab[i].te1:Hide()
		end)		
		
		Historia_Skills_Tab[i].te1 = Historia_Skills_Tab[i]:CreateTexture(nil,"ARTWORK")
		Historia_Skills_Tab[i].te1:SetTexture("Interface\\ContainerFrame\\UI-Icon-QuestBorder")
		Historia_Skills_Tab[i].te1:SetPoint("TOPLEFT", Historia_Skills_Tab[i], 2, -2)
		Historia_Skills_Tab[i].te1:SetPoint("BOTTOMRIGHT", Historia_Skills_Tab[i], -2, 2)	
		Historia_Skills_Tab[i].te1:Hide()
		
		Historia_Skills_Tab[i].te2 = Historia_Skills_Tab[i]:CreateTexture(nil,"ARTWORK")
		Historia_Skills_Tab[i].te2:SetTexture(Skills_icon[1])
		Historia_Skills_Tab[i].te2:SetPoint("TOPLEFT", Historia_Skills_Tab[i], 4, -4)
		Historia_Skills_Tab[i].te2:SetPoint("BOTTOMRIGHT", Historia_Skills_Tab[i], -4, 4)	
		Historia_Skills_Tab[i].te2:Show()		
	end	
end 


-------------------------------------------------------------------------------
--  Fill the Skills scroll table
--	Fill the extensions part
-------------------------------------------------------------------------------
function Historia_HS_Build_Table(id)
	row_count = 0
	Historia_Skills_Table = {}
	Historia_Skills_Scroll_Table = {}	

	for i=1,cfg.Historia_HIS1_Buttons do
		Historia_HS_JJ.list[i].name2:SetText(L["Not recorded"])
	end	

	for idx = 1, #HistoriaLocalDb.Skills do
		if HistoriaLocalDb.Skills[idx].name == Historia_Skill_Tabs[id] then
			Historia_Skills_Table = {}
			row_count = row_count + 1
			--	Set the Skill name above the scroll frame
			if row_count ==  1 then
				Historia_HS_IH.F1:SetText(HistoriaLocalDb.Skills[idx].name)
			end	
		
			Historia_Skills_Table.Text		= HistoriaLocalDb.Skills[idx].name
			Historia_Skills_Table.Rank		= HistoriaLocalDb.Skills[idx].rank
			Historia_Skills_Table.Time		= HistoriaLocalDb.Skills[idx].time
			tinsert(Historia_Skills_Scroll_Table,1,Historia_Skills_Table)

			for i=1,cfg.Historia_HIS1_Buttons do
				if HistoriaLocalDb.Skills[idx].rank == tostring(cfg.Historia_HIS1_Text[i]) then
					Historia_HS_JJ.list[i].name2:SetText("")
					Historia_HS_JJ.list[i].name2:SetText(format(date("%a, %b %d %Y %H:%M",HistoriaLocalDb.Skills[idx].time)))
				end
			end			
		end	
	end	
		
	HSSF1.scrollFrame.ScrollBar:SetValue(0)	
	HSSF1_ScrollFrameUpdate()	
end	


-------------------------------------------------------------------------------
--  Skills scroll table the scrolling part.
-------------------------------------------------------------------------------
function HSSF1_ScrollFrameUpdate()
	local offset = FauxScrollFrame_GetOffset(HSSF1.scrollFrame)
	FauxScrollFrame_Update(HSSF1.scrollFrame, row_count, Historia_HS_NO_SCROLLBUTTONS, 16)

	for i = 1, Historia_HS_NO_SCROLLBUTTONS do
		local idx = offset + i
		if idx <= row_count then
			HSSF1.list[i].name1:SetText(format(date("%a, %b %d %Y %H:%M", Historia_Skills_Scroll_Table[idx].Time)))
			if Historia_Skills_Scroll_Table[idx].Rank == 99999 then
				HSSF1.list[i].name2:SetText(NONE)
			else	
				HSSF1.list[i].name2:SetText(Historia_Skills_Scroll_Table[idx].Rank)
			end
			HSSF1.list[i]:Show()
		else
			HSSF1.list[i]:Hide()
		end	
	end	
end


-------------------------------------------------------------------------------
--	Properly fill the Skills tabs
-------------------------------------------------------------------------------
local function WTX_TTX_Tabs()
	--	Determine the used weapon skills
	for i = 1, #HistoriaLocalDb.Skills do
		for j = 1, #cfg.WTX do
			if HistoriaLocalDb.Skills[i].name == cfg.WTX[j][1] then
				cfg.WTX[j][3] = true
			end
		end
	end
	
	--	Determine the used Class Skills
	for i = 1, #HistoriaLocalDb.Skills do
		for j = 1, #cfg.TTX do
			if HistoriaLocalDb.Skills[i].name == cfg.TTX[j][1] then
				cfg.TTX[j][3] = true
			end
		end
	end	
	
	local idx = 0
	Historia_Skill_Tabs = {}
	--	Fill and show/hide the Weapon Skill buttons
	for i = 1, #cfg.WTX do
		if cfg.WTX[i][3] then
			idx = idx + 1 
			if idx <= Historia_NUMBEROFSKILLSTABS then
				Historia_Skills_Tab[idx].te2:SetTexture(cfg.WTX[i][2])
				Historia_Skills_Tab[idx]:Show()
				Historia_Skill_Tabs[idx] = cfg.WTX[i][1] 
			end	
		end
	end
	
	--	Fill and show/hide the Class Skills buttons
	for i = 1, #cfg.TTX do
		if cfg.TTX[i][3] then
			idx = idx + 1 
			if idx <= Historia_NUMBEROFSKILLSTABS then
				Historia_Skills_Tab[idx].te2:SetTexture(cfg.TTX[i][2])
				Historia_Skills_Tab[idx]:Show()
				Historia_Skill_Tabs[idx] = cfg.TTX[i][1] 
			end	
		end
	end	
	
	--	Hide the buttons that are not used
	idx = idx + 1
	if idx < Historia_NUMBEROFSKILLSTABS then
		for i = idx, Historia_NUMBEROFSKILLSTABS do
			Historia_Skills_Tab[i]:Hide()
		end
	end
end


-------------------------------------------------------------------------------
--	Create the rest of the Skills frame
-------------------------------------------------------------------------------
function Historia_Skills_TheRest()
	--  Create a reference frame for the rest of the Skills info.
	local Historia_HS_J = CreateFrame("Frame","Historia_HS_J",Historia_HS)
	Historia_HS_J:SetPoint("TOPRIGHT", "Historia_HS_H", "BOTTOMRIGHT", 0, -16)
	Historia_HS_J:SetPoint("BOTTOMLEFT", "Historia_HS", "BOTTOMRIGHT", -320, 0)	
	--Historia_HS_J:SetBackdrop(cfg.Historia_backdrop2)	

	local Historia_HS_JH = CreateFrame("Frame","Historia_HS_JH",Historia_HS_J)
	Historia_HS_JH:SetPoint("TOPLEFT","Historia_HS_J",0,0)
	Historia_HS_JH:SetPoint("BOTTOMRIGHT","Historia_HS_J","TOPRIGHT",0,-24)
	Historia_HS_JH:SetBackdrop(cfg.Historia_backdrop2)	
	
	Historia_HS_JH.F1 = Historia_HS_JH:CreateFontString(nil,"ARTWORK","GameFontWhite")
	Historia_HS_JH.F1:SetPoint("CENTER","Historia_HS_JH",0,0)
	Historia_HS_JH.F1:SetText(L["Statistics"])	
	
	local Historia_HS_JJ = CreateFrame("Frame","Historia_HS_JJ",Historia_HS_J)
	Historia_HS_JJ:SetPoint("TOPLEFT","Historia_HS_JH","BOTTOMLEFT",0,0)
	Historia_HS_JJ:SetPoint("BOTTOMRIGHT","Historia_HS_J",0,-0)
	--Historia_HS_JJ:SetBackdrop(cfg.Historia_backdrop2)	

	Historia_HS_JJ.list = {}
	for i=1,cfg.Historia_HIS1_Buttons do
		Historia_HS_JJ.list[i] = CreateFrame("Button",nil,Historia_HS_JJ)
		Historia_HS_JJ.list[i]:SetSize(64,32)
		Historia_HS_JJ.list[i]:SetPoint("TOPLEFT",Historia_HS_JJ,"TOPLEFT",0,(i-1)*-32-4)
		Historia_HS_JJ.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HS_JJ.list[i]:Show()
		
		Historia_HS_JJ.list[i].name1 = Historia_HS_JJ.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormalHuge")
		Historia_HS_JJ.list[i].name1:SetSize(64,32)
		Historia_HS_JJ.list[i].name1:SetPoint("CENTER",0,0)	
		Historia_HS_JJ.list[i].name1:SetText(cfg.colors["Gold"] .. cfg.Historia_HIS1_Text[i] .. cfg.colors["End"])		

		Historia_HS_JJ.list[i] = CreateFrame("Button",nil,Historia_HS_JJ)
		Historia_HS_JJ.list[i]:SetSize(256,32)
		Historia_HS_JJ.list[i]:SetPoint("TOPLEFT",Historia_HS_JJ,"TOPLEFT",64,(i-1)*-32-4)
		Historia_HS_JJ.list[i]:SetBackdrop(cfg.Historia_backdrop2)
		Historia_HS_JJ.list[i]:Show()

		Historia_HS_JJ.list[i].name2 = Historia_HS_JJ.list[i]:CreateFontString(nil,"ARTWORK","GameFontNormal")
		Historia_HS_JJ.list[i].name2:SetSize(160,32)
		Historia_HS_JJ.list[i].name2:SetPoint("LEFT",8,0)	
		Historia_HS_JJ.list[i].name2:SetJustifyH("LEFT")	
		Historia_HS_JJ.list[i].name2:SetText(L["Not recorded"])		
	end	
	
	local Historia_HS_K = CreateFrame("Frame","Historia_HS_K",Historia_HS)
	Historia_HS_K:SetPoint("TOPRIGHT","Historia_HS_J","TOPLEFT",-16,0)
	Historia_HS_K:SetPoint("BOTTOMLEFT","Historia_HS_J", "BOTTOMLEFT",-96,0)	
	Historia_HS_K:SetBackdrop(cfg.Historia_backdrop2)		
	
	Historia_HS_K.list = {}
	for i = 1,6 do
		Historia_HS_K.list[i] = CreateFrame("Button",nil,Historia_HS_K)
		Historia_HS_K.list[i]:SetSize(64,64)
		Historia_HS_K.list[i]:SetPoint("TOP",Historia_HS_K,0,(i-1)*-70-2)
		Historia_HS_K.list[i]:Show()
		
		Historia_HS_K.list[i].te1 = Historia_HS_K.list[i]:CreateTexture(nil,"ARTWORK")
		Historia_HS_K.list[i].te1:SetTexture(cfg.Icons .."challenges-gold")		
		Historia_HS_K.list[i].te1:SetPoint("TOPLEFT",Historia_HS_K.list[i],0,0)
		Historia_HS_K.list[i].te1:SetPoint("BOTTOMRIGHT",Historia_HS_K.list[i],0,0)		
		Historia_HS_K.list[i]:Show()		
	end
end


-------------------------------------------------------------------------------
--  Handle the Skills Tab
-------------------------------------------------------------------------------
function Historia_HS_Update()
	--  Properly fill the Skills tabs
	WTX_TTX_Tabs()
	--	Fill the Scroll table and the rest
	Historia_HS_Build_Table(1)
end