--[[	*** Historia ***
Written by : Yukyuk, EU-Moonglade
--]]

-------------------------------------------------------------------------------
--  From _Global to local.
-------------------------------------------------------------------------------
local _G = _G


-------------------------------------------------------------------------------
--  AddOn name space.
-------------------------------------------------------------------------------
local FOLDER_NAME, private = ...

local cfg = private.cfg
local addon = cfg.addon_name


-------------------------------------------------------------------------------
--  Libstubs.
-------------------------------------------------------------------------------
local L 		= LibStub("AceLocale-3.0"):GetLocale("Historia")
local LDB		= LibStub("LibDataBroker-1.1")
local LDBIcon 	= LibStub("LibDBIcon-1.0")
local LibQTip 	= LibStub:GetLibrary("LibQTip-1.0")


-------------------------------------------------------------------------------
--  Constants.
-------------------------------------------------------------------------------
local Historia_NUMBEROFTABS = 8


-------------------------------------------------------------------------------
--	This table holds the Tab buttons
-------------------------------------------------------------------------------
local Historia_Tab = {}

-------------------------------------------------------------------------------
--	Handle the tab buttons
-------------------------------------------------------------------------------
function Historia_Handle_Tabs(id)
	for i = 1,Historia_NUMBEROFTABS do
		Historia_Tab[i].te1:Show()
		Historia_Tab[i].te2:Hide()	
	end
	
	Historia_Tab[id].te1:Hide()
	Historia_Tab[id].te2:Show()
	Historia_Tab[id].te3:Hide()	

	Historia_HM:Hide()
	Historia_HL:Hide()	
	Historia_HC:Hide()	
	Historia_HP:Hide()	
	Historia_HS:Hide()	
	Historia_HQ:Hide()	
	Historia_HT:Hide()	
	Historia_HA:Hide()		

	if id == 1 then	
		Historia_HM:Show()
		if not (Historia_SelectedTab == 1) then
			Historia_Mainframe_Update()
		end	
	elseif id == 2 then
		Historia_HL:Show()	
		if not (Historia_SelectedTab == 2) then
			Historia_HL_Update()
		end		
	elseif id == 3 then
		Historia_HC:Show()	
		if not (Historia_SelectedTab == 3) then
			Historia_HC_Update()
		end
	elseif id == 4 then
		Historia_HP:Show()	
		if not (Historia_SelectedTab == 4) then
			Historia_HP_Update()
		end
	elseif id == 5 then
		Historia_HS:Show()	
		if not (Historia_SelectedTab == 5) then
			Historia_HS_Update()
		end
	elseif id == 6 then
		Historia_HQ:Show()	
		if not (Historia_SelectedTab == 6) then
			Historia_HQ_Update()
		end
	elseif id == 7 then
		Historia_HT:Show()	
		if not (Historia_SelectedTab == 7) then
			Historia_HT_Update()
		end			
	else	
		Historia_HA:Show()	
		if not (Historia_SelectedTab == 8) then
			Historia_HA_Update()
		end	
	end	
end


-------------------------------------------------------------------------------
--  Create the tab buttons.
-------------------------------------------------------------------------------
local Historia_SelectedTab = 1
function Historia_UI_Tabs()
	for i = 1,Historia_NUMBEROFTABS do
		Historia_Tab[i] = CreateFrame("Button",nil,Historia_UI)
		Historia_Tab[i]:SetSize(96,48)
		Historia_Tab[i]:SetPoint("TOPLEFT",Historia_UI,"BOTTOMLEFT",(i-1)*110, 0)
		Historia_Tab[i]:SetBackdrop(cfg.Historia_backdrop0)
		Historia_Tab[i]:Show()
		Historia_Tab[i]:SetScript("OnClick", function(self, button)
			Historia_SelectedTab = i
			Historia_Handle_Tabs(i)		
		end)			
		Historia_Tab[i]:SetScript("OnEnter", function(self, button)
			if not (Historia_SelectedTab == i) then
				Historia_Tab[i].te3:Show()
			end	
		end)		
		Historia_Tab[i]:SetScript("OnLeave", function(self, button)
			Historia_Tab[i].te3:Hide()
		end)	
		
		Historia_Tab[i].te1 = Historia_Tab[i]:CreateTexture(nil,"BACKGROUND",nil,2)
		Historia_Tab[i].te1:SetTexture("Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-AchievementBackground")
		Historia_Tab[i].te1:SetPoint("TOPLEFT", Historia_Tab[i], 2, -2)
		Historia_Tab[i].te1:SetPoint("BOTTOMRIGHT", Historia_Tab[i], -2, 2)
		Historia_Tab[i].te1:SetTexCoord(0,0.3,0,0.3)
		
		Historia_Tab[i].te2 = Historia_Tab[i]:CreateTexture(nil,"BACKGROUND",nil,3)
		Historia_Tab[i].te2:SetTexture("Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-Parchment-Horizontal-Desaturated")
		Historia_Tab[i].te2:SetPoint("TOPLEFT", Historia_Tab[i], 2, -2)
		Historia_Tab[i].te2:SetPoint("BOTTOMRIGHT", Historia_Tab[i], -2, 2)	
		Historia_Tab[i].te2:Hide()
		
		Historia_Tab[i].te3 = Historia_Tab[i]:CreateTexture(nil,"BACKGROUND",nil,4)
		Historia_Tab[i].te3:SetTexture("Interface\\ContainerFrame\\UI-Icon-QuestBorder")
		Historia_Tab[i].te3:SetPoint("TOPLEFT", Historia_Tab[i], 2, -2)
		Historia_Tab[i].te3:SetPoint("BOTTOMRIGHT", Historia_Tab[i], -2, 2)	
		Historia_Tab[i].te3:Hide()		

		Historia_Tab[i].text = Historia_Tab[i]:CreateFontString(Historia_Tab[i], "ARTWORK", "GameFontNormal")
		Historia_Tab[i].text:SetAllPoints()
		
		if i == 1 then
			Historia_Tab[i].text:SetText(L["Main"])	
		elseif i == 2 then		
			Historia_Tab[i].text:SetText(LEVEL)	
		elseif i == 3 then		
			Historia_Tab[i].text:SetText(CURRENCY)
		elseif i == 4 then		
			Historia_Tab[i].text:SetText(TUTORIAL_TITLE38)	
		elseif i == 5 then		
			Historia_Tab[i].text:SetText(SKILLS)	
		elseif i == 6 then		
			Historia_Tab[i].text:SetText(QUESTS_LABEL)
		elseif i == 7 then				
			Historia_Tab[i].text:SetText(L["Time line"])				
		else	
			Historia_Tab[i].text:SetText(ACHIEVEMENTS)
		end		
	end	
end


-------------------------------------------------------------------------------
--  Create the User interface
-------------------------------------------------------------------------------
function Historia_Create_UI()
	local Historia_UI = CreateFrame("Frame","Historia_UI",UIParent)
	Historia_UI:SetWidth(cfg.ADDON_WIDTH)
	Historia_UI:SetHeight(cfg.ADDON_HEIGHT)	
	Historia_UI:SetPoint(HistoriaGlobalDb.UI.point,
						UIParent,
						HistoriaGlobalDb.UI.relativePoint,
						HistoriaGlobalDb.UI.pos.X,
						HistoriaGlobalDb.UI.pos.Y)	

	Historia_UI:SetFrameStrata("LOW")
	Historia_UI:SetMovable(true)
	Historia_UI:EnableMouse(true)
	Historia_UI:SetClampedToScreen(true)
	Historia_UI:SetScript("OnShow", Historia_OnShow)
	Historia_UI:SetScript("OnMouseDown", Historia_UI.StartMoving)
	Historia_UI:SetScript("OnMouseUp", function(self, button)
		self:StopMovingOrSizing()
		local point, _, relativePoint, xOffset, yOffset = Historia_UI:GetPoint()
		HistoriaGlobalDb.UI.point = point
		HistoriaGlobalDb.UI.relativePoint = relativePoint
		HistoriaGlobalDb.UI.pos.X = xOffset
		HistoriaGlobalDb.UI.pos.Y = yOffset
	end)	
	
	--  Create the background 
	Historia_UI:SetBackdrop(cfg.Historia_backdrop1)
	
	--  Make Historia closable with the escape key.
	tinsert(UISpecialFrames,"Historia_UI") 
	
	--  Define the font string for the version 
	Historia_UI.F1 = Historia_UI:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	Historia_UI.F1:SetPoint("BOTTOM" ,"Historia_UI", 0, 4)
	Historia_UI.F1:SetText(format("%s %s", cfg.addon_name, cfg.addon_version))	
	
	--	Create the close button
    local Historia_Close = CreateFrame("Button",nil,Historia_UI)
    Historia_Close:SetPoint("TOPRIGHT",2,2)
    Historia_Close:SetSize(24,24)
	Historia_Close.t = Historia_Close:CreateTexture(nil,"BACKGROUND",nil,1)
	Historia_Close.t:SetTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Up")
	Historia_Close.t:SetAllPoints(Historia_Close)	
	Historia_Close:EnableMouse(true)
	Historia_Close:RegisterForClicks("AnyUp")	
 	Historia_Close:SetScript("OnClick", function(self, button) Historia_Toggle_UI() end)	
	
	Historia_UI:Hide()	
	
	--  Create the tab frames.
	Historia_Main_Frame()
	Historia_Level()
	Historia_Currency()
	Historia_Professions()
	Historia_Skills()
	Historia_Quests()
	Historia_TimeLine()
	Historia_Achievements()
	
	--  Create the TAB buttons
	Historia_UI_Tabs()	
end


-------------------------------------------------------------------------------
--  Toggle the user interface
-------------------------------------------------------------------------------
function Historia_Toggle_UI()
    if Historia_UI:IsVisible() then
		Historia_UI:Hide()	
    else
        Historia_UI:Show()
		Historia_Handle_Tabs(1)		
    end
end